;//	LZE DECODE ROUTINE
;//	Original Copyright (C)1995,2008 GORRY.
;//	Porting for 8080 by Kei Moroboshi 2020/Apr
	.8080

;	PUBLIC	DECODE_LZE
;==============================================================================
;LZE data decoder
;Input:
;	HL	LZE encoded data address(*)
;	DE	extracting address
;(*)lze.exe add 4 byte header as extracted size(big-endian).
;Therefore, you must set HL as LZE data top + 4(skip the header).
;Broken:
;	AF,BC,DE,HL
;Example:
;	LXI	H,LZE_DATA+4
;	LXI	D,EXTRACT_AREA
;	CALL	DECODE_LZE
;==============================================================================

DECODE_LZE:		;Entry
	MVI	B,1	;BitCount=1

STORE:
	MOV	C,A
	MOV	A,M	;*(DECODEPtr++) = *(LZEPtr++);
	INX	H
	STAX	D	;DE=DECODEPtr
	INX	D
	MOV	A,C

MAINLP:
	DCR	B	;BitTest() {
	JNZ	SKIP
	MOV	A,M
	INX	H
	MVI	B,8
SKIP:	ADD	A	;}

	JC	STORE		;1:Store
				;0x:Copy

;Copy Byte Distance or Word Distance
	DCR	B	;BitTest() {
	JNZ	SKIP0
	MOV	A,M
	INX	H
	MVI	B,8
SKIP0:	ADD	A	;}

	JC	COPYWD	;01:Copy with Word Distance
			;00:Copy with Byte Distance
COPYBD:
	DCR	B	;BitTest() {
	JNZ	SKIP00
	MOV	A,M
	INX	H
	MVI	B,8
SKIP00:	ADD	A	;}

	MOV	C,A
	MVI	A,0
	RAL
	PUSH	D
	 MOV	E,A
	 MOV	A,C

	 DCR	B	;BitTest() {
	 JNZ	SKIP01
	 MOV	A,M
	 INX	H
	 MVI	B,8
SKIP01:	 ADD	A	;}

	 MOV	C,A	;Save BitData
	 MOV	A,E	;adc	CopyCount,CopyCount
	 ADC	A	;a=CopyCount
	POP	D
	PUSH	B
	MOV	C,A	;C=CopyCount
	MOV	A,M	;	Distance = -256+((int)*(LZEPtr++));
	INX	H
	PUSH	H
	MOV	L,A
	MVI	H,0FFH

CPCNTP2:		;CopyCount ++;
	INR	C	;inc	CopyCount
CPCNTP1:
	INR	C	;inc	CopyCount

	DAD	D	;HL:CopyPtr=HL:Distance + DE:DECODEPtr
LDIR:	MOV	A,M	;copy {
	STAX	D
	INX	H
	INX	D
	DCR	C
	JNZ	LDIR	;}
	POP	H
	POP	B
	MOV	A,C
	JMP	MAINLP

;COPY with Word Distance
COPYWD:
	MOV	C,A	;Save BitData
	PUSH	B

	MOV	B,M
	INX	H
	MOV	C,M
	INX	H		;BC=DISTANCE
	PUSH	H
				;mov	CopyCount,Distance

;24*3
	MOV	A,B
	RAR			;shr	Distance,1
	MOV	H,A
	MOV	A,C
	RAR
	MOV	L,A

	MOV	A,H
	RAR			;shr	Distance,1
	MOV	H,A
	MOV	A,L
	RAR
	MOV	L,A

	MOV	A,H
	RAR			;shr	Distance,1
	MOV	H,A
	MOV	A,L
	RAR
	MOV	L,A

	MVI	A,0E0H		;or	DistanceH,0e0h
	ORA	H
	MOV	H,A

	MOV	A,C
	ANI	7		;and	CopyCount,7
	MOV	C,A
	JNZ	CPCNTP2

	POP	B	;10	XTHL	;18
	LDAX	B	;	MOV	A,M
	INX	B	;	INX	H
	PUSH	B	;11	XTHL	;18

	MOV	C,A	;C=CopyCountL
	ORA	A
	JNZ	CPCNTP1

DECODE_LZE_e:
	POP	H
	POP	B
	RET


